monitor/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
from django.views.generic import RedirectView


urlpatterns = [
    path('admin/', admin.site.urls),
    path('sas/', include("sas.urls")),
    path('', RedirectView.as_view(url='sas/', permanent=True)),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)


urlpatterns += [
    path('accounts/', include('django.contrib.auth.urls')),
]

sas/urls.py
from django.urls import path, re_path
from . import views

urlpatterns = [
    path('', views.index, name='index'),
]


urlpatterns += [
    path('users/', views.UserListView.as_view(), name='users'),
    path('user/<int:pk>/', views.UserDetailView.as_view(), name='user-detail'),
    path('user/<int:pk>/sessions/', views.SessionListView.as_view(), name='user-sessions'),
    path('monitor/<int:pk>/challenges', views.ChallengeListView.as_view(), name='monitor-challenges'),
    path('monitor/<int:pk>/parcourss', views.ParcoursListView.as_view(), name='monitor-parcours'),
    path('student/<int:pk>/challenges', views.ChallengeListView.as_view(), name='student-challenges'),
    path('student/<int:pk>/parcourss', views.ParcoursListView.as_view(), name='student-parcours'),
    path('user/create/', views.UserCreate.as_view(), name='user-create'),
    path('user/<int:pk>/update/', views.UserUpdate.as_view(), name='user-update'),
    path('user/<int:pk>/delete/', views.UserDelete.as_view(), name='user-delete'),
]


urlpatterns += [
    path('modules/', views.ModuleListView.as_view(), name='modules'),
    path('module/<int:pk>/', views.ModuleDetailView.as_view(), name='module-detail'),
    path('module/create/', views.ModuleCreate.as_view(), name='module-create'),
    path('module/<int:pk>/update/', views.ModuleUpdate.as_view(), name='module-update'),
    path('module/<int:pk>/delete/', views.ModuleDelete.as_view(), name='module-delete'),
]

urlpatterns += [
    path('skills/', views.SkillListView.as_view(), name='skills'),
    path('skill/<int:pk>/workshops/', views.WorkshopListView.as_view(), name='skill-workshops'),
    path('skill/<int:pk>/challenges', views.ChallengeListView.as_view(), name='skill-challenges'),
    path('skill/<int:pk>/', views.SkillDetailView.as_view(), name='skill-detail'),
    path('skill/create/', views.SkillCreate.as_view(), name='skill-create'),
    path('skill/<int:pk>/update/', views.SkillUpdate.as_view(), name='skill-update'),
    path('skill/<int:pk>/delete/', views.SkillDelete.as_view(), name='skill-delete'),
]

urlpatterns += [
    path('workshops/', views.WorkshopListView.as_view(), name='workshops'),
    path('workshop/<int:pk>/', views.WorkshopDetailView.as_view(), name='workshop-detail'),
    path('workshop/<int:pk>/sessions/', views.SessionListView.as_view(), name='workshop-sessions'),
    path('workshop/create/', views.WorkshopCreate.as_view(), name='workshop-create'),
    path('workshop/<int:pk>/update/', views.WorkshopUpdate.as_view(), name='workshop-update'),
    path('workshop/<int:pk>/delete/', views.WorkshopDelete.as_view(), name='workshop-delete'),
]

urlpatterns += [
    path('sessions/', views.SessionListView.as_view(), name='sessions'),
    path('session/<int:pk>/', views.SessionDetailView.as_view(), name='session-detail'),
    path('session/create/', views.SessionCreate.as_view(), name='session-create'),
    path('session/<int:pk>/update/', views.SessionUpdate.as_view(), name='session-update'),
    path('session/<int:pk>/delete/', views.SessionDelete.as_view(), name='session-delete'),
]

urlpatterns += [
    path('challenge/create/', views.ChallengeCreate.as_view(), name='challenge-create'),
    path('challenge/<int:pk>/', views.ChallengeDetailView.as_view(), name='challenge-detail'),
    path('challenge/<int:pk>/update/', views.ChallengeUpdate.as_view(), name='challenge-update'),
    path('challenge/<int:pk>/delete/', views.ChallengeDelete.as_view(), name='challenge-delete'),
    path('challenge/<int:pk>/sessions/', views.SessionListView.as_view(), name='challenge-sessions'),
    path('challenges/', views.ChallengeListView.as_view(), name='challenges'),
]

urlpatterns += [
    path('mission/create/', views.MissionCreate.as_view(), name='mission-create'),
    path('mission/<int:pk>/', views.MissionDetailView.as_view(), name='mission-detail'),
    path('mission/<int:pk>/update/', views.MissionUpdate.as_view(), name='mission-update'),
    path('mission/<int:pk>/delete/', views.MissionDelete.as_view(), name='mission-delete'),
    path('mission/<int:pk>/sessions/', views.SessionListView.as_view(), name='mission-sessions'),
    path('missions/', views.MissionListView.as_view(), name='missions'),
]

urlpatterns += [
    path('partners/', views.PartnerListView.as_view(), name='partners'),
    path('partner/<int:pk>/', views.PartnerDetailView.as_view(), name='partner-detail'),
    path('partner/create/', views.PartnerCreate.as_view(), name='partner-create'),
    path('partner/<int:pk>/update/', views.PartnerUpdate.as_view(), name='partner-update'),
    path('partner/<int:pk>/delete/', views.PartnerDelete.as_view(), name='partner-delete'),
]

urlpatterns += [
    path('parcourss/', views.ParcoursListView.as_view(), name='parcours'),
    path('parcours/<int:pk>/', views.ParcoursDetailView.as_view(), name='parcours-detail'),
    path('parcours/create/', views.ParcoursCreate.as_view(), name='parcours-create'),
    path('parcours/<int:pk>/update/', views.ParcoursUpdate.as_view(), name='parcours-update'),
    path('parcours/<int:pk>/delete/', views.ParcoursDelete.as_view(), name='parcours-delete'),
]

urlpatterns += [
    path('evals/', views.EvalListView.as_view(), name='evals'),
    path('eval/<int:pk>/', views.EvalDetailView.as_view(), name='eval-detail'),
    path('eval/create/', views.EvalCreate.as_view(), name='eval-create'),
    path('eval/<int:pk>/update/', views.EvalUpdate.as_view(), name='eval-update'),
    path('eval/<int:pk>/delete/', views.EvalDelete.as_view(), name='eval-delete'),
]

"""
urlpatterns += [
    path('user/<int:pk_user>/session/<int:pk_session>/<int:pk>/view', views.EvalDetailView.as_view(), name='eval-detail'),
    path('evals/', views.EvalListView.as_view(), name='evals'),
    path('user/<int:pk_user>/session/<int:pk_session>/create/', views.EvalCreate.as_view(), name='eval-create'),
    path('user/<int:pk_user>/session/<int:pk_session>/<int:pk>/update/', views.EvalUpdate.as_view(), name='eval-update'),
    path('user/<int:pk_user>/session/<int:pk_session>/<int:pk>/delete/', views.EvalDelete.as_view(), name='eval-delete'),
    path('user/<int:pk_user>/session/<int:pk_session>/evals/', views.EvalsUserSession.as_view(), name='evals-user-session'),
]
"""
urlpatterns += [
    path('convention/<int:pk>/parcourss', views.ParcoursListView.as_view(), name='convention-parcourss'),
    path('convention/<int:pk>/students', views.UserListView.as_view(), name='convention-students'),
    path('convention/<int:pk>/partners', views.PartnerListView.as_view(), name='convention-partners'),
]

sas/models.py
from django.db import models
from django.urls import reverse
from django.utils import timezone
from django.contrib.auth.models import User
from django.db.models.signals import post_save
from django.dispatch import receiver
from django.contrib.auth.decorators import login_required, permission_required
from django.http import HttpResponseRedirect
from django.utils.translation import gettext_lazy as _
from django.core import serializers
import json
from django.db.models import F


# Create your models here.

class Profile(models.Model):
    web_verbose_name = "Participant"
    web_verbose_name_plural = "Participants"
    user = models.OneToOneField(User, on_delete=models.CASCADE, null=True)
    ismonitor = models.BooleanField(default=False)
    birthdate = models.DateField(null=True, blank=True)
    address = models.CharField(max_length=500, null=True, blank=True)
    sessions = models.ManyToManyField('Session', blank=True)
    evals = models.ManyToManyField('Eval', blank=True)

    class Meta:
        verbose_name = 'Bénéficiaire'
        verbose_name_plural = 'Bénéficiaires'

    def first_name(self):
        return self.user.first_name

    def last_name(self):
        return self.user.last_name


    def __str__(self):
        return f"{self.user.last_name} {self.user.first_name}"

    def get_absolute_url(self):
        """Returns the url to access a detail record for this user."""
        return reverse('user-detail', args=[str(self.id)])

    def sorted_evals(self):
        sorted_evals = []
        for ses in self.sessions.all():
             evas = []
             for eva in self.evals.all():
                 if eva.session == ses:
                     evas.append(eva)
             sorted_evals.append({'session': ses, 'evals': evas})
        return sorted_evals



class Module(models.Model):
    web_verbose_name = "Module"
    web_verbose_name_plural = "Modules"
    name = models.CharField(max_length=200)
    summary = models.TextField(max_length = 200, help_text='Enter a brief description of the content of the module', null=True, blank=True)
    description = models.TextField(help_text='Enter a complete description of the content of the module', null=True, blank=True)
     
    class Meta:
        ordering = ['name']
        verbose_name = "Module"
        verbose_name_plural = "Modules"

    def __str__(self):
        return f'{self.name}'

    def get_absolute_url(self):
        """Returns the url to access a detail record for this module."""
        return reverse('module-detail', args=[str(self.id)])

    def get_edit_url(self):
        return reverse('module-update', args=[str(self.id)])

    def get_delete_url(self):
        return reverse('module-delete', args=[str(self.id)])

    def class_name(self):
        return self._meta.verbose_name

# A skill is something that you are able to achieve
class Skill(models.Model):
    web_verbose_name = "Compétence"
    web_verbose_name_plural = "Compétences"
    name = models.CharField(max_length=200, verbose_name="Nom")
    description = models.TextField(max_length=1000, null=True, blank=True, verbose_name="Description")

    modules = models.ManyToManyField(Module, related_name="skill_modules", verbose_name="Modules")


    # Difficulty is noted beetween 1 and 5 
    difficulty = models.CharField(
        verbose_name="Difficulté",
        max_length=1,
        default="3", 
        choices=[('1', "1"), ('2', "2"), ('3', "3"), ('4', "4"), ('5', "5")], 
     )

    #tools = ""
    #ressources = ""

    class Meta:
        ordering = ['name']
        verbose_name = 'Compétence'
        verbose_name_plural = 'Compétences'

    def __str__(self):
        return f"{self.name}"

    def get_absolute_url(self):
        return reverse('skill-detail', args=[str(self.id)])

    def get_edit_url(self):
        return reverse('skill-update', args=[str(self.id)])

    def get_delete_url(self):
        return reverse('skill-delete', args=[str(self.id)])

    def class_name(self):
        return self._meta.verbose_name

# A challenge is something to accomplish, in general terms, e.g. "install a computer"
class Challenge(models.Model):
    web_verbose_name = "Challenge"
    web_verbose_name_plural = "Challenges"
    name = models.CharField(max_length=200, null=True)
    description = models.TextField(max_length=1000)
 
    modules = models.ManyToManyField(Module, blank=True, related_name="challenge_modules", related_query_name="challenge_modules")
    challenges = models.ManyToManyField(self, blank=True, related_name="challenge_challenges", related_query_name="challenge_challenges")

    skills = models.ManyToManyField(Skill, blank=True, related_name="challenge_skills", related_query_name="Compétences")
    #get_all_skills_ids = MU.get_related_ids(self, skills, main=main_skill, far=modules)

    # Difficulty is noted beetween 1 and 5 
    difficulty = models.CharField(
        max_length=1,
        default="3", 
        choices=[('1', "1"), ('2', "2"), ('3', "3"), ('4', "4"), ('5', "5")], 
     )

    class Meta:
        ordering = ['name']
        verbose_name = 'Challenge'
        verbose_name_plural = 'Challenges'

    def __str__(self):
        return f"{self.name}"

    def get_absolute_url(self):
        return reverse('challenge-detail', args=[str(self.id)])

    def get_edit_url(self):
        return reverse('challenge-update', args=[str(self.id)])

    def get_delete_url(self):
        return reverse('challenge-delete', args=[str(self.id)])

    def class_name(self):
        return self._meta.verbose_name


# A mission is an instance of  challenge, e.g. "install a computer for x"
class Mission(models.Model):
    web_verbose_name = "Mission"
    web_verbose_name_plural = "Missions"
    challenge = models.ForeignKey(Challenge, on_delete=models.PROTECT, related_name='mission_challenge')
    context = models.TextField(max_length=1000, null=True)
    participants = models.ManyToManyField(User, blank=True, related_name="mission_participants")
    start_date = models.DateTimeField(default=timezone.now)
    end_date = models.DateTimeField(default=timezone.now)
    monitor = models.ForeignKey(User, on_delete=models.PROTECT, null=True, related_name="mission_monitor") # don't forget to set monitor to NULL is monitor is archived BEFORE challenge take place (issue #17)

    class Meta:
        ordering = ['context']
        verbose_name = 'Mission'
        verbose_name_plural = 'Missions'

    def __str__(self):
        return f"{self.context}"

    def get_absolute_url(self):
        return reverse('mission-detail', args=[str(self.id)])

    def get_edit_url(self):
        return reverse('mission-update', args=[str(self.id)])

    def get_delete_url(self):
        return reverse('mission-delete', args=[str(self.id)])

    def class_name(self):
        return self._meta.verbose_name


class Workshop(models.Model):
    web_verbose_name = "Workshop"
    web_verbose_name_plural = "Workshops"
    name = models.CharField(max_length=200, null=True)
    description = models.TextField(max_length=1000, null=True)
    start_date = models.DateTimeField(default=timezone.now)
    end_date = models.DateTimeField(default=timezone.now)

    # Difficulty is noted beetween 1 and 5 
    difficulty = models.CharField(
        max_length=1,
        default="3", 
        choices=[('1', "1"), ('2', "2"), ('3', "3"), ('4', "4"), ('5', "5")], 
    )

    challenges = models.ManyToManyField(Challenge, blank=True, related_name='workshop_challenges')

    modules = models.ManyToManyField(Module, blank=True, related_name='workshop_modules')

    skills = models.ManyToManyField(Skill, blank=True, related_name='workshop_skills', related_query_name="Compétences")

    monitor = models.ForeignKey(User, on_delete=models.PROTECT, null=True, related_name="workshop_monitor") # don't forget to set monitor to NULL is monitor is archived BEFORE workshop take place (issue #17)

    class  Meta:
        ordering = ['start_date', 'end_date']
        verbose_name_plural = 'Ateliers'
        verbose_name = 'Atelier'

    def __str__(self):
        return f"{self.name}"

    def get_absolute_url(self):
        return reverse('workshop-detail', args=[str(self.id)])

    def get_edit_url(self):
        return reverse('workshop-update', args=[str(self.id)])

    def get_delete_url(self):
        return reverse('workshop-delete', args=[str(self.id)])

    def class_name(self):
        return self._meta.verbose_name



class Partner(models.Model):
    web_verbose_name = "Partenaire"
    web_verbose_name_plural = "Partenaires"
    name = models.CharField(max_length=500)
    address = models.CharField(max_length=500, null=True, blank=True)
    intermediary = models.ForeignKey(User, null=True, on_delete=models.PROTECT, related_name="Intermédiaire")

    class Meta:
        ordering = ['name']
        verbose_name = "Partenaire"
        verbose_name_plural = "Partenaires"

    def __str__(self):
        return f"{self.name}"

    def get_absolute_url(self):
        return reverse('partner-detail', args=[str(self.id)])

    def get_edit_url(self):
        return reverse('partner-update', args=[str(self.id)])

    def get_delete_url(self):
        return reverse('partner-delete', args=[str(self.id)])

    def class_name(self):
        return self._meta.verbose_name



# A parcours is a convention beetween a student and the organization, along with a list of modules to evaluate and challenges to take
class Parcours(models.Model):
    web_verbose_name = "Parcours"
    web_verbose_name_plural = "Parcours"

    user = models.ForeignKey(User, null=True, on_delete=models.PROTECT, related_name="parcours_student")
    tiers = models.ForeignKey(Partner, null=True, on_delete=models.PROTECT, related_name="parcours_tiers")
    monitor = models.ForeignKey(User, on_delete=models.PROTECT, null=True, related_name="parcours_monitor")

    class Status(models.TextChoices):
        COLLEGE = 'CO', _('Stage au collège')

sas/templates/sas/challenge_detail.html
{% extends "include/base.html" %}

{% block title %} Challenge {{ challenge }} {% endblock %} 

{% block body_class %}{% endblock %}

<!-- Specific Page CSS goes HERE  -->
{% block stylesheets %}{% endblock stylesheets %}

{% block content %}
<div class="page-wrapper">
  
  {% include 'include/bandeau.html' with model=challenge %}

  <div class="page-body">
    <div class="container-xl">
      <div class="row row-deck row-cards">

        {% block fields_list %}
        {% include 'include/fields_list.html' with model=challenge fields=fields %}
        {% endblock fields_list %}

          {% block related_list %}  
          {% include 'include/related_list.html' with related=related %}
          {% endblock related_list %}


      </div><!-- end row -->
    </div><!-- end container -->
  </div><!-- end page-body -->



</div><!-- end page-wrapper -->
{% endblock content%}
{% block javascripts %}
{% include 'include/related_list_js.html' with related=related %}
{% endblock javascripts %}

sas/templates/sas/eval_list.html
{% extends "base_generic.html" %}

{% block content %}
  <h1>Liste des évaluations</h1>
  {% if user_list %}
  <ul>
    {% for user in user_list %}
      <li> {{ user.profile }}
        <ul>
            {% for i in user.profile.sorted_evals %}
            <li>
                {{ i.session }} : 
                <ul>
                    {% for e in i.evals %}
                    <li>
                        <a href="{% url 'eval-detail' pk=e.id pk_user=e.user.id pk_session=e.moduleinstance.id %}">{{ e.comment }}</a>
                    </li>
                    {% endfor %}
                </ul>
            </li>
            {% endfor %}
         </ul>
      </li>
    {% endfor %}
  </ul>
  {% else %}
    <p>There are no evaluations.</p>
  {% endif %}
{% endblock %}

sas/templates/sas/mission_confirm_delete.html
{% extends "base_generic.html" %}

{% block content %}

<h1>Delete Mission</h1>

<p>Are you sure you want to delete the mission: {{ mission }}?</p>

<form action="" method="POST">
  {% csrf_token %}
  <input type="submit" value="Yes, delete.">
</form>

{% endblock %}

sas/templates/sas/parcours_confirm_delete.html
{% extends "base_generic.html" %}

{% block content %}

<h1>Delete Session</h1>

<p>Are you sure you want to delete this session: {{ session }}?</p>

<form action="" method="POST">
  {% csrf_token %}
  <input type="submit" value="Yes, delete.">
</form>

{% endblock %}

sas/templates/sas/parcours_list.html
{% extends "include/base.html" %}

{% block content %}
  <h1>Liste des modules</h1>
  <button><a href="{% url 'module-create'%}">Créer un module</a></button>
  {% if module_list %}
  <ul>
    {% for module in module_list %}
      <li>
        <a href="{{ module.get_absolute_url }}">{{ module.name }}</a>
      </li>
    {% endfor %}
  </ul>
  {% else %}
    <p>There are no modules.</p>
  {% endif %}
{% endblock %}

sas/templates/sas/partner_confirm_delete.html
{% extends "base_generic.html" %}

{% block content %}

<h1>Delete Session</h1>

<p>Are you sure you want to delete this session: {{ session }}?</p>

<form action="" method="POST">
  {% csrf_token %}
  <input type="submit" value="Yes, delete.">
</form>

{% endblock %}

sas/templates/sas/partner_form.html
{% extends "include/base.html" %}

{% block title %} Nouveau partenaire {% endblock %} 

{% block body_class %}{% endblock %}

<!-- Specific Page CSS goes HERE  -->
{% block stylesheets %}{% endblock stylesheets %}

{% block content %}
<div class="page-wrapper">
{% include 'include/bandeau.html' with title="Ajouter un partenaire" %}

{% include 'include/modelform.html' with card="Nouveau partenaire" %}


</div><!-- end page-wrapper  -->

{% endblock content%}
{% block javascripts %}
{% endblock javascripts %}

sas/templates/sas/partner_list.html
{% extends "include/base.html" %}

{% block content %}
  <h1>Liste des modules</h1>
  <button><a href="{% url 'module-create'%}">Créer un module</a></button>
  {% if module_list %}
  <ul>
    {% for module in module_list %}
      <li>
        <a href="{{ module.get_absolute_url }}">{{ module.name }}</a>
      </li>
    {% endfor %}
  </ul>
  {% else %}
    <p>There are no modules.</p>
  {% endif %}
{% endblock %}

sas/templates/sas/user_confirm_delete.html
{% extends "base_generic.html" %}

{% block content %}

<h1>Delete User</h1>

<p>Are you sure you want to delete the user: {{ user }}?</p>

<form action="" method="POST">
  {% csrf_token %}
  <input type="submit" value="Yes, delete.">
</form>

{% endblock %}

sas/templates/sas/user_detail.html
{% extends "include/base.html" %}

{% block title %} Module {{module}} {% endblock %} 

{% block body_class %}{% endblock %}

<!-- Specific Page CSS goes HERE  -->
{% block stylesheets %}{% endblock stylesheets %}

{% block content %}
<div class="page-wrapper">
  
  {% include 'include/bandeau.html' with model=module %}

  <div class="page-body">
    <div class="container-xl">
      <div class="row row-deck row-cards">

          <div class="col-12">
            <div class="card">
              <div class="card-header">
                <h3 class="card-title">
                  {{ module.name }}
                </h3>
              </div><!-- end card header -->

              <div class="card-body">
                <div class="markdown">
                  <div class="d-flex mb-3">
                    <h1 class="m-0">Module: {{ module.name }}</h1>
                  </div>
                  <div class="mb-3">
                    <p><strong>Résumé:</strong> {{ module.summary }}</p>
                    <p><strong>Description:</strong> {{ module.description }}</p>
                  </div>
                </div>
              </div>
            </div><!-- end card -->
          </div><!-- end col -->

          {% block related_list %}  
          {% include 'include/related_list.html' with related=related %}
          {% endblock related_list %}


      </div><!-- end row -->
    </div><!-- end container -->
  </div><!-- end page-body -->



</div><!-- end page-wrapper -->
{% endblock content%}
{% block javascripts %}
{% include 'include/related_list_js.html' with related=related %}
{% endblock javascripts %}

sas/templates/sas/user_update.html
{% extends "include/base.html" %}

{% block title %} Éditer | {{ module.name }} {% endblock %} 

{% block body_class %}{% endblock %}

<!-- Specific Page CSS goes HERE  -->
{% block stylesheets %}{% endblock stylesheets %}

{% block content %}
<div class="page-wrapper">
{% include 'include/bandeau.html' with title=module.name%}

{% include 'include/modelform.html' with module=module %}


</div><!-- end page-wrapper  -->

{% endblock content%}
{% block javascripts %}
{% endblock javascripts %}

sas/templates/sas/workshop_list.html
{% extends "include/base.html" %}

{% block content %}
  <h1>Liste des modules</h1>
  <button><a href="{% url 'module-create'%}">Créer un module</a></button>
  {% if module_list %}
  <ul>
    {% for module in module_list %}
      <li>
        <a href="{{ module.get_absolute_url }}">{{ module.name }}</a>
      </li>
    {% endfor %}
  </ul>
  {% else %}
    <p>There are no modules.</p>
  {% endif %}
{% endblock %}

sas/templates/sas/workshop_update.html
{% extends "include/base.html" %}

{% block title %} Éditer atelier| {{ workshop.name }} {% endblock %} 

{% block body_class %}{% endblock %}

<!-- Specific Page CSS goes HERE  -->
{% block stylesheets %}{% endblock stylesheets %}

{% block content %}
<div class="page-wrapper">
{% include 'include/bandeau.html' with title=workshop.name%}

{% include 'include/modelform.html' with model=workshop %}


</div><!-- end page-wrapper  -->

{% endblock content%}
{% block javascripts %}
{% endblock javascripts %}